
#include "dac.h"

// send one byte
void spi_send(char data)
{
	SPDR = data;				// start transmission
	while(!(SPSR& 1<<SPIF));	// wait for transmission complete
}

// dac initialization routine
void init_dac(void)
{
	// init SPI for DAC
	SPI_DDR |= (1<<SPI_MOSI)|(1<<SPI_SCK)|(1<<SPI_CS);	// MOSI and SCK as output
	SPCR = (1<<SPE)|(1<<MSTR);		// master, clock rate fck/4 = 2Mhz
	SPI_PORT |= (1<<SPI_CS);		// cs high
	SPI_PORT &= ~(1<<SPI_CS);		// cs low
	spi_send(0b11110000);			// set all dac outputs to 0
	spi_send(0b00000000);
	SPI_PORT |= (1<<SPI_CS);		// cs high
}

// send DAC command
void dac_output(uint8_t channel, CHDATA value)
{
	SPI_PORT &= ~(1<<SPI_CS);	// cs low
	char data[2];				// build 16bit command: A3A2A1A0D9D8D7D6 D5D4D3D2D1D0X1X0
	data[0] = (channel<<4)|((value.bit.adc>>6)&0xF);
	data[1] = value.bit.adc << 2;
	spi_send(data[0]);			// send DAC adress and value
	spi_send(data[1]);
	SPI_PORT |= (1<<SPI_CS);	// cs high
}
